// Mandelbrot 1.1a
// Carlos Baquero cbm@di.uminho.pt
lgray(int x,int y) {
  bitmap(20+x*3, 60+y*3,"034e4");
}
dgray(int x,int y) {
  bitmap(20+x*3, 60+y*3,"03eae");
}
black(int x,int y) {
  bitmap(20+x*3, 60+y*3,"03eee");
}
string opt[6]; int o;
int si;
showopt()
{
  rect(0,0,20,159,30,0);
  text(20,20,opt[o]);             
}
doopt()
{
  int b;
  b=bstate();
  if(b==1) { o--; if(o==-1) o=5; showopt(); return; }
  if(b==-1) { o++; if(o==6) o=0; showopt(); }
}
dotime(int pos)
{
  int sc,eta,m,s;
  sc=seconds()-si;
  eta=1200*sc/pos-sc;
  m=eta/60; s=eta%60;
  text(20,30,"ETA: " +m+":"+s+"       ");
  resetaot();
}
main()
{
  int x,y,i,px,py,bail;
  float xc,yc,xd,yd;
  float xt,yt,xk,yk,t1,t2;
  int pen,e;
  opt[0]="Zoom In";
  opt[1]="Zoom Out";
  opt[2]="Save/Export";
  opt[3]="Reset";
  opt[4]="New Dept";
  opt[5]="Exit";
  o=0;
  graph_on();
  title("Mandelbrot");
   if (mmfind( "<data,mandelbrot,1.1>" )) 
  { mmgetl();
    xc=mmgetl(); yc=mmgetl();
    xd=mmgetl(); yd=mmgetl();
    bail=mmgetl();
    mmclose();
  }
  else 
  {
    xc=-0.2;yc=0;
    xd=0.08;yd=0.11;
    bail=18;
  }
  do { clearg();
  showopt();
  pen=1; si=seconds();
  frame(1,18,58,142,152,0);
  text(20,40,"Dept: "+bail);

  for(x=0; x<40 && pen; x++) {
    xk=xc+(x-20)*xd;
    for(y=0; y<30 && pen; y++)
  {
    xt=xk;
    yt=yk=yc+(y-15)*yd;
    i=0;
    t1=xt*xt; t2=yt*yt;
    while (t1+t2<4 && i++ < bail)
    {
      yt=2*xt*yt;
      xt=t1-t2;
      xt=xt+xk; yt=yt+yk;
      t1=xt*xt; t2=yt*yt;
    }
   if(pstate()) { pen=0; break; }
   doopt();
   if(y%5==0) dotime(x*30+y);
   if (i>bail) continue;
   i=i%6;
   if ( i==1) { 
 bitmap(21+x*3, 61+y*3,"018");
 continue; }
   if ( i==2) { bitmap(20+x*3, 61+y*3,"02c"); continue; }
   if ( i==3) { bitmap(20+x*3, 61+y*3, "03e"); continue; }
   if ( i==4) { lgray(x,y); continue; }
   if ( i==5) { dgray(x,y); continue; }
   if ( i==0) { black(x,y); continue; }
  } }

  text(20,30,"Time:" + (seconds()-si)/60 + ":" + (seconds()-si)%60 + "     ");
  if (pen) while(!pstate()) doopt();
  px=penx(); py=peny();
  if(o==4) {
    bail=gets("Enter calculation deepness (n*6)"); continue;
  }
 if(o==0) {
  xc=xc+((px-20)/3-20)*xd;
  yc=yc+((py-60)/3-15)*yd;
  xd=xd/3; yd=yd/3;
  continue;
}
 if(o==1) {
  xd=xd*3; yd=yd*3;
  continue;
}
 if(o==2) {
  if (mmfind( "<data,mandelbrot,1.1>" )) { mmdelete(); beep(1); }
  mmnew(); 
  mmputs( "<data,mandelbrot,1.1>" );
  mmputs("\n"+xc); 
  mmputs("\n"+yc);
  mmputs("\n"+xd); 
  mmputs("\n"+yd);
  mmputs("\n"+bail+"\n");
  mmclose();
}
 if(o==3) {
  xc=-0.2;yc=0;
  xd=0.08;yd=0.11; bail=18;
  continue;
}
  } while(o!=5);
  graph_off(); 
}